<?php 
/**
* actividades_consulta.php
*
* aplicacin que consulta el listado de actividades presentadas.
* 
* @package    	Plataforma Colectiva de Informacin Territorial: UBATIC2014
* @subpackage 	BASE
* @author     	Universidad de Buenos Aires
* @author     	<mario@trecc.com.ar>
* @author    	http://www.uba.ar/
* @author    	http://www.trecc.com.ar/recursos/proyectoubatic2014.htm
* @author		based on TReCC SA Procesos Participativos Urbanos, development. www.trecc.com.ar/recursos
* @copyright	2015 Universidad de Buenos Aires
* @copyright	esta aplicacin se desarrollo sobre una publicacin GNU 2014 TReCC SA
* @license    	http://www.gnu.org/licenses/gpl.html GNU General Public License, version 3 (GPL-3.0)
* Este archivo es parte de TReCC(tm) paneldecontrol y de sus proyectos hermanos: baseobra(tm), TReCC(tm) intraTReCC  y TReCC(tm) Procesos Participativos Urbanos.
* Este archivo es software libre: tu puedes redistriburlo 
* y/o modificarlo bajo los trminos de la "GNU General Public License" 
* publicada por la Free Software Foundation, version 3
* 
* Este archivo es distribuido por si mismo y dentro de sus proyectos 
* con el objetivo de ser til, eficiente, predecible y transparente
* pero SIN NIGUNA GARANTA; sin siquiera la garanta implcita de
* CAPACIDAD DE MERCANTILIZACIN o utilidad para un propsito particular.
* Consulte la "GNU General Public License" para ms detalles.
* 
* Si usted no cuenta con una copia de dicha licencia puede encontrarla aqu: <http://www.gnu.org/licenses/>.
* 
*
*/

/**
* genera listado html de actividades
*
* @param int $ID id de la argumentacin. null devuelve la totalidad de argumentacines cargadas por este usuario.
* @param int $seleccion permite definir modos de seleccin, algunos modos de seleccin pueder ser restringidos a ciertos tpos de usuarios.
* @return array Retorna el listado de actividades, sus imgenes y sus localizacines
*/
function actividadesconsulta($ID,$seleccion){

	global $UsuarioI, $PanelI, $FILTRO, $Freportedesde, $Freportehasta, $FILTROFECHAD, $FILTROFECHAH, $config, $Conec1;
	
	
	if(!isset($Freportedesde)){$Freportedesde = '9999-12-30';}
/*medicion de rendimiento lamp*/
	$starttimef = microtime(true);
	if(!isset($Freportehasta)||$Freportehasta=='0000-00-00'){$Freportehasta = '9999-12-30';}


	/* consulta todas las argumentacines para el usuaurio habilitado, si est seteado $ID la busqueda se restringe a la argumentacin cuya id coincida ocn el valor de $ID*/	
	if($ID!=''){$whereid = " AND `PARTICactividades`.`id` = '".$ID."'";}else{$whereid='';}
	$query="
	 
		SELECT `actividades`.`id`,
		    `actividades`.`x0`,
		    `actividades`.`y0`,
		    `actividades`.`xF`,
		    `actividades`.`yF`,
		    `actividades`.`geometria`,
		    `actividades`.`consigna`,
		    `actividades`.`valorAct`,
		    `actividades`.`valorDat`,
		    `actividades`.`valorUni`,
		    `actividades`.`textoAct`,
		    `actividades`.`textoDat`,
		    `actividades`.`objeto`,
		    `actividades`.`desde`,
		    `actividades`.`hasta`,
		    `actividades`.`resultados`,
		    `actividades`.`marco`,
		    `actividades`.`nivel`,
		    `actividades`.`zz_AUTOUSUARIOCREAC`
		FROM `MAPAUBA`.`actividades`	
		
		LEFT JOIN 
			usuarios
			ON usuarios.id = actividades.zz_AUTOUSUARIOCREAC
	
	";	
	$ConsultaACT = mysql_query($query,$Conec1);

	echo mysql_error($Conec1);
	while($fila=mysql_fetch_assoc($ConsultaACT)){
		$ACT[$fila['id']]=$fila;
	}
	if($ID!=''&&mysql_num_rows($ConsultaARG)==0){
		$ACT[]['resumen']="error en la seleccin de la argumentacin";
	}
	
	
	$query="
		SELECT `atributos`.`id`,
		    `atributos`.`valor`,
		    `atributos`.`texto`,
		    `atributos`.`link`,
		    `atributos`.`id_usuarios`,
		    `atributos`.`id_actividades`,
		    `atributos`.`fecha`,
		    `atributos`.`escala`,
		    `atributos`.`nivelUsuario`,
		    `atributos`.`areaUsuario`
		FROM `MAPAUBA`.`atributos`;
	";
	$ConsultaATT = mysql_query($query,$Conec1);

	echo mysql_error($Conec1);
	
	while($fila=mysql_fetch_assoc($ConsultaATT)){
		$ATT[$fila['id']]=$fila;
		
	}
		
	
	$query="SELECT `geodatos`.`id`,
	    `geodatos`.`x`,
	    `geodatos`.`y`,
	    `geodatos`.`geometria`,
	    `geodatos`.`id_usuarios`,
	    `geodatos`.`id_actividades`,
	    `geodatos`.`fecha`
	FROM `MAPAUBA`.`geodatos`;
	";
	$ConsultaGEO = mysql_query($query,$Conec1);

	echo mysql_error($Conec1);
	
	while($fila=mysql_fetch_assoc($ConsultaGEO)){
		$f=array_merge($fila,$ATT[$fila['id']]);
		$ACT[$fila['id_actividades']]['GEO'][$fila['id']]=$f;
	}
	
	return $ACT;
}	


/**
* genera listado html de actividades
*
 * 
* @param int $ID id de la argumentacin. null devuelve la totaclidad de argumentacines cargadas por este usuario.
* @return string Retorna el listado en formato html
*/
function actividadeslistado($ID,$seleccion){
	global $UsuarioI, $PanelI, $FILTRO, $Freportedesde, $Freportehasta, $FILTROFECHAD, $FILTROFECHAH, $config;
	
	/* consulta array de argumentaicnes */
	$actividades = 	actividadesconsulta($ID,$seleccion);

	/* la cadeana $fila contendr cdigo HTLM */
	$fila="
	<div class='fila'>
		<div class='titulo dato descripcion'>
		Descripcin
		</div>
		<div class='titulo dato fecha'>
		Fecha
		</div>
		<div class='titulo dato autor'>
		Autor
		</div>
		<div class='titulo dato autor'>
		Participantes
		</div>
		<div class='titulo dato imagenes'>
		Consigna
		</div>
		<div class='titulo dato localizaciones'>
		Resultados
		</div>
	</div>
	";
	$filas[]=$fila;	
	
	
	foreach($actividades as $actividad){
		if($actividad['resumen']!=''){$resumen=$actividad['resumen'];}else{$resumen="-vacio-";}		
		$fila="
			<div class='fila'>
				<div class='dato descripcion'>
					<a href='./actividad.php?actividad=".$actividad['id']."'>".$resumen."</a>
				</div>	
				<div class='dato fecha'>
					".$actividad['zz_AUTOFECHACREACION']."
				</div>	
				<div class='dato autor'>
					".$actividad['usunombre']." ".$actividad['usuapellido']."</a>
				</div>	
				<div class='dato autor'>
				0 -> ".count($actividad['GEO'])."
				</div>
				<div class='dato imagenes'>
		";
		$imgasoc=$actividad['imagenes'];
		$datoimagen='';
		foreach($imgasoc as $img){
			$datoimagen.="<img class='elemento' src='".$img['FI_documento']."'>";
		}
		if($datoimagen==''){$datoimagen="No se han guardado imgenes para esta argumentacin";}
		
		$fila.=$datoimagen;
		$fila.=	"
				</div>
				<div class='dato localizaciones'>
		";
		$localiz=$actividad['localizaciones'];
		
		$datoloc='';
				
		foreach($localiz as $loc){
			$datoloc.="<div class='elemento' title='lat:".$loc['latitud']."\nlon:".$loc['longitud']."'>".$loc['latitud']."/".$loc['longitud']."</div>";
		}
		if($datoloc==''){$datoloc="No se han guaradado localizaciones para esta argumentacin";}
		$fila.=$datoloc;
		$fila.=	"</div>";
					
		$fila.="						
			</div>
		";		
		$filas[]=$fila;
	}
	$resultado="";
	foreach($filas as $f){
		$resultado.=$f;
	}
	if(count($actividades)==0){
		$resultado='No se han registrado actividades.';
	}
	
	return $resultado;
}




function actividadesreporte($ID,$seleccion){
	global $UsuarioI, $PanelI, $FILTRO, $Freportedesde, $Freportehasta, $FILTROFECHAD, $FILTROFECHAH, $config;
	
	// consulta array de argumentaicnes 
	$actividades = 	actividadesconsulta($ID,$seleccion);
	print_r($actividades);
	/* la cadeana $fila contendr cdigo HTLM 
			`actividades`.`id`,
		    `actividades`.`resumen`,
		    `actividades`.`actividad`,
		    `actividades`.`id_p_PARTICactores_id`,
		    `actividades`.`zz_AUTOUSUARIO`,
		    `actividades`.`zz_AUTOFECHACREACION`,
		    
			usuarios.nombre as usunombre,
			usuarios.apellido as usuapellido*/
	
	foreach($actividades as $actividad){
		if($actividad['resumen']!=''){$resumen=$actividad['resumen'];}else{$resumen="-vacio-";}		
		$fila="
			<div class='actividad'>
			
				<h2>".$actividad['usunombre']." ".$actividad['usuapellido']."<span>(idusuario n:".$actividad['id_p_PARTICactores_id'].")</span></h2>
				<h2>".$resumen."</h2>(creada:".$actividad['zz_AUTOFECHACREACION'].")
				<p>".$actividad['actividad']."</p>
		";
		$imgasoc=$actividad['imagenes'];
		$datoimagen='';
		foreach($imgasoc as $img){
			$datoimagen.="<img class='ilustracion' src='".$img['FI_documento']."'>";
		}
		if($datoimagen==''){$datoimagen="No se han guardado imgenes para esta argumentacin";}
		
		$fila.=$datoimagen;
		
		$localiz=$actividad['localizaciones'];
		if(count($localiz)==0){
			$fila.="no se cargaron localizacines para esta argumentacin";
		}else{
			if($seleccion=='todo'){
				$fila.="<iframe class='mapa' src='./actividadmuestralocalizacion.php?actividad=".$actividad['id']."'></iframe>";
			}else{
				$fila.="<iframe class='mapa' src='./actividadlocalizacion.php?actividad=".$actividad['id']."'></iframe>";	
			}
			
		}
		$fila.="</div>";
		$filas[]=$fila;
	}
	$resultado="";
	foreach($filas as $f){
		$resultado.=$f;
	}
	if(count($actividades)==0){
		$resultado='No se han registrado actividades.';
	}
	
	return $resultado;
}
?>